; XL5
; 256b SID music
; This is a cover of Jeff "X-Large 5"

; step1: 309 bytes (normal code of the tune)
; step2: 301 bytes (use $0326 start up)
; step3: 297 bytes (use Frantic sbx/sync thecnique)
; step4: 292 bytes (rearrange pat1 and inx)
; step4: 290 bytes (use ldy directly)
; step5: 277 bytes (use 0 value already setted)
; step6: 274 bytes (use common set of control register+fix Frantic code) +1 must be added


  processor 6502

curTrack = $57   ; this and +7 and +14 are 0 at sturtup of after loading
curPat   = $58   ; this and +7 and +14 are 0 at sturtup of after loading
duration = $27
DUR = 8

   ;org 2049
   ;.byte $0b,$08,$e8,$03,$9e,"2061",0,0,0
   ;.org 2061

  .org $0326  

  .byte $2A, $03
  .byte $ED, $F6 

  .org $032A

      sei                    ; disable interrupt

      lda  #$0F
      sta  $D418             ; volume max
      ;lda  #$11              ; triangle waveform
      ;sta  $D40B             ; voice 2
      ;sta  $D412             ; voice 3
      ;lda  #$41
      ;sta  $D404             ; voice 1
      ;lda  #$C9
      ;sta  $D406             ; SR voice 1
      ;lda  #$69
      ;sta  $D40d             ; SR voice 2
      ;lda  #$29
      ;sta  $d414             ; SR voice 3

      lda  #$30
      sta  $d414             ; SR voice 3
      asl
      sta  $D40d             ; SR voice 2
      asl
      sta  $D406             ; SR voice 1
 
      lda  #$08
      sta  $D403             ; wave high

      ;ldx  #$00
      ;stx  curTrack
      ;stx  curPat
      ;stx  curTrack+7
      ;stx  curPat+7
      ;stx  curTrack+14
      ;stx  curPat+14
      ; inx
      ldx  #1
      stx  duration
      lda  #1+DUR+DUR
      sta  duration+7
      lda  #1+DUR+DUR+DUR+DUR
      sta  duration+14

sync:
     ;lda  #$ff
loopSync:
     cpx  $D012
     bne  loopSync

     ;ldx  #0                 ; start from first voice
      ldx  #14                ; start from last voice
loopVoice:
      dec  duration,x
      bne  nextVoice
      lda  #DUR
      sta  duration,x

      lda  #$11
      cpx  #0
      bne  skip
      lda  #$41
      sta  $D404,x           ; control register of voice
skip:

nextNote:
                             ; read next note
      ldy  curPat,x      
      lda  pat,y
      beq  nextTrack
      inc  curPat,x          ; go to next note
                             ; put note y to sid x
      tay
      lda  freqLo-1,y
      sta  $D400,x
      lda  freqHi-1,y
      sta  $D401,x

; increment voice index and test for last voice      
nextVoice:
      nop  ; without this it goed out of sync!
      ;txa
      ;clc
      ;adc  #7
      ;tax
      ;cmp  #$11
      ;bcs  sync
      ;bcc  loopVoice

      lda  #$ff
      .byte $cb,7            ; sbx #7 
      bpl  loopVoice
      bmi  sync

nextTrack:
      inc  curTrack,x
      ldy  curTrack,x
      lda  track,y
      bmi  resetTrack
      sta  curPat,x
      bpl  nextNote
resetTrack:
      lda  #0
      sta  curTrack,x
      sta  curPat,x
      beq  nextNote

; note declaration
END = 0
F1  = 1
Fd1 = 2
Gd1 = 3
F2  = 4
Fd2 = 5
Gd2 = 6
Gd3 = 7
Ad3 = 8
C4  = 9
Cd4 = 10
D4  = 11
Dd4 = 12
F4  = 13
Fd4 = 14
G4  = 15
Gd4 = 16
Ad4 = 17

freqLo:
  .byte 231 ;F1 
  .byte  20 ;F#1 
  .byte 116 ;G#1
  .byte 207 ;F2 
  .byte  39 ;F#2
  .byte 232 ;G#2
  .byte 208 ;G#3
  .byte 129 ;A#3
  .byte 103 ;C4 
  .byte 112 ;C#4
  .byte 137 ;D4 
  .byte 178 ;D#4
  .byte  59 ;F4 
  .byte 157 ;F#4
  .byte  20 ;G4 
  .byte 160 ;G#4
  .byte   3 ;A#4

freqHi:
  .byte 2  ;F1 
  .byte 3  ;F#1 
  .byte 3  ;G#1
  .byte 5  ;F2 
  .byte 6  ;F#2
  .byte 6  ;G#2
  .byte 13 ;G#3
  .byte 15 ;A#3
  .byte 17 ;C4 
  .byte 18 ;C#4
  .byte 19 ;D4 
  .byte 20 ;D#4
  .byte 23 ;F4 
  .byte 24 ;F#4
  .byte 26 ;G4 
  .byte 27 ;G#4
  .byte 31 ;A#4



pat:
pat1:
  .byte Gd1, Gd2, Gd3, END

pat2:
  .byte Fd1, END

pat3:
  .byte Gd1, Gd2, Dd4, Gd1, Gd2, D4, Gd1, Gd2, C4, Gd1, END

pat4:
  .byte Gd2, Ad3, Gd1, Gd3, Gd2, Ad3, END 

pat5:
  .byte D4, Dd4, Gd2, C4, Gd2, Gd3, END 

pat6:
  .byte D4, Dd4, Gd2, G4, Gd2, Gd4, END

pat7:
  .byte D4, Dd4, Gd2, Gd4, Gd2, Ad4, END

pat8: 
  .byte F1, F2, Gd4, F1, F2, G4, F1, Dd4, F2, C4, F1, Dd4, F4, F1, C4, Dd4, Fd1, Fd2, Fd4, Fd1, Fd2, F4, END

pat9:
  .byte F1, END

pat10: 
  .byte Cd4, Fd2, Gd3, END

pat11:
  .byte Ad3, Fd2, Cd4, Fd1, Gd3, END

track:
  .byte (pat1-pat), (pat1-pat), (pat1-pat), (pat1-pat)
  .byte (pat1-pat), (pat2-pat), (pat1-pat), (pat1-pat)
  .byte (pat1-pat), (pat2-pat), (pat1-pat), (pat2-pat)
  .byte (pat3-pat), (pat4-pat), (pat3-pat), (pat5-pat)
  .byte (pat3-pat), (pat4-pat), (pat3-pat), (pat6-pat)
  .byte (pat3-pat), (pat4-pat), (pat3-pat), (pat5-pat)
  .byte (pat3-pat), (pat4-pat), (pat3-pat), (pat7-pat)
  .byte (pat8-pat), (pat9-pat), (pat10-pat), (pat9-pat)
  .byte (pat11-pat), (pat8-pat), (pat2-pat), (pat10-pat)
  .byte (pat2-pat), (pat11-pat), $FF